#!/usr/bin/env python3

import sys
from pentest_tls import port_scanner

def process(ports: list, ip: str, PU, PS, is_root=False, is_verbose=False) -> None:
    open_ports = []
    opened = False
    
    # Prompt
    if PU:
        if is_root:
            print("[*] Running with root privileges, using Scapy UDP scan...")
        else:
            print("[*] Running without root privileges, using socket UDP scan...")
    else:
        if is_root:
            print("[*] Running with root privileges, using SYN scan...")
        else:
            print("[*] Running without root privileges, using connect scan...")
    
    for port in sorted(ports):
        sys.stdout.flush()
        if PU:
            opened |= port_scanner.scan_udp_port(ip, port, is_root=is_root, is_verbose=is_verbose)
            if PS:
                opened |= port_scanner.scan_tcp_port(ip, port, is_root=is_root, is_verbose=is_verbose)
        else:
            opened |= port_scanner.scan_tcp_port(ip, port, is_root=is_root, is_verbose=is_verbose)
        if opened:
            open_ports.append(port)
    if open_ports:
        print(f"\nOpened: {sorted(open_ports)}")
    else:
        print("\nNo open ports were detected.")
